/*
///
//Ⱥ
//:2015/6/17
//:2016/3/30
//汾V2.0
//ȨУؾ
//Copyright(C) ާܿƼ޹˾
 */

/* ----------------------- Platform includes --------------------------------*/
#include "port.h"

/* ----------------------- Modbus includes ----------------------------------*/
#include "mb.h"
#include "mbport.h"

#include "sys.h"

/* ----------------------- Static variables ---------------------------------*/
UCHAR           ucGIEWasEnabled = FALSE;
UCHAR           ucCriticalNesting = 0x00;

/* ----------------------- Start implementation -----------------------------*/
void
vMBPortSerialEnable( BOOL xRxEnable, BOOL xTxEnable )
{
    ENTER_CRITICAL_SECTION(  );
    if( xRxEnable )
    {
        USART_ITConfig(USART2, USART_IT_RXNE, ENABLE);
		GPIO_ResetBits(GPIOD,GPIO_Pin_3);
    }
    else
    {
		USART_ITConfig(USART2, USART_IT_RXNE, DISABLE);
		GPIO_SetBits(GPIOD,GPIO_Pin_3);
    }
    if( xTxEnable )
    {
		USART_ITConfig(USART2, USART_IT_TC, ENABLE);
    }
    else
    {
		USART_ITConfig(USART2, USART_IT_TC, DISABLE);
    }
    EXIT_CRITICAL_SECTION(  );
}

BOOL
xMBPortSerialInit( UCHAR ucPort, ULONG ulBaudRate, UCHAR ucDataBits, eMBParity eParity )
{
	BOOL    bInitialized = TRUE;
	GPIO_InitTypeDef GPIO_InitStruct;
	USART_InitTypeDef USART_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA| RCC_APB2Periph_GPIOD | RCC_APB2Periph_AFIO, ENABLE);
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2,ENABLE);//ʹUSART2ʱ

	GPIO_InitStruct.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_InitStruct.GPIO_Pin = GPIO_Pin_3;
	GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOD,&GPIO_InitStruct);

	GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_InitStruct.GPIO_Pin = GPIO_Pin_2;
	GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA,&GPIO_InitStruct);

	GPIO_InitStruct.GPIO_Mode = GPIO_Mode_IN_FLOATING; //GPIO_Mode_IPU;
	GPIO_InitStruct.GPIO_Pin = GPIO_Pin_3;
	GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA,&GPIO_InitStruct);

	USART_InitStructure.USART_BaudRate = ulBaudRate;
	switch ( eParity )
	{
	case MB_PAR_NONE:
		USART_InitStructure.USART_Parity = USART_Parity_No;
		break;
	case MB_PAR_ODD:
		USART_InitStructure.USART_Parity = USART_Parity_Odd;
		break;
	case MB_PAR_EVEN:
		USART_InitStructure.USART_Parity = USART_Parity_Even;
		break;
	}
	switch ( ucDataBits )
	{
	case 8:
		if(eParity==MB_PAR_NONE)
		USART_InitStructure.USART_WordLength = USART_WordLength_8b;
		else
		USART_InitStructure.USART_WordLength = USART_WordLength_9b;
		break;
	case 7:
		break;
	default:
		bInitialized = FALSE;
	}
	if( bInitialized )
	{
		ENTER_CRITICAL_SECTION(  );
		USART_InitStructure.USART_StopBits = USART_StopBits_1;
		USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
		USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
		USART_Init(USART2, &USART_InitStructure);

		USART_Cmd(USART2, ENABLE);

		NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn; 			//ʹܴ2ж
		NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;	//ռȼ0
		NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;			//ȼ0
		NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;				//ʹⲿжͨ
		NVIC_Init(&NVIC_InitStructure); 							//NVIC_InitStructָĲʼNVICĴ

		EXIT_CRITICAL_SECTION(  );
	}
	return bInitialized;
}

BOOL
xMBPortSerialPutByte( CHAR ucByte )
{
	USART_SendData(USART2, ucByte);

    return TRUE;
}

BOOL
xMBPortSerialGetByte( CHAR * pucByte )
{
    *pucByte = (u8)USART_ReceiveData(USART2);	//ȡBUFFER
    return TRUE;
}

void USART2_IRQHandler(void)
{
	if(USART_GetITStatus(USART2,USART_IT_RXNE) == SET)
	{
		pxMBFrameCBByteReceived(  );

		USART_ClearITPendingBit(USART2, USART_IT_RXNE);
	}

	if(USART_GetITStatus(USART2,USART_IT_TC) == SET)
	{
	    pxMBFrameCBTransmitterEmpty(  );

		USART_ClearITPendingBit(USART2, USART_IT_TC);
	}
}

void
EnterCriticalSection( void )
{
  __disable_irq();
}

void
ExitCriticalSection( void )
{
  __enable_irq();
}


