/*
 * FreeModbus Libary: MSP430 Port
 * Copyright (C) 2006 Christian Walter <wolti@sil.at>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * File: $Id: porttimer.c,v 1.3 2007/06/12 06:42:01 wolti Exp $
 */

/* ----------------------- Platform includes --------------------------------*/
#include "port.h"

/* ----------------------- Modbus includes ----------------------------------*/
#include "mb.h"
#include "mbport.h"

/* ----------------------- Defines ------------------------------------------*/
/* Timer ticks are counted in multiples of 50us. Therefore 20000 ticks are
 * one second.
 */
#define MB_TIMER_TICKS          ( 20000L )

/* ----------------------- Start implementation -----------------------------*/
BOOL
xMBPortTimersInit( USHORT usTim1Timeout50us )
{  
//  SysTick_ITConfig(ENABLE);
//  SysTick_SetReload(1000*usTim1Timeout50us);
//  SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK);

	TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
	NVIC_InitTypeDef	NVIC_InitStructure;

	//TIM_OCInitTypeDef  TIM_OCInitStructure;

	/* TIM6 clock enable */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);
	/* Time base configuration */
	TIM_TimeBaseStructure.TIM_Period = 1000*usTim1Timeout50us;    	//һ¼װԶװؼĴڵֵȡֵ0x00000xFFFF֮䡣
	TIM_TimeBaseStructure.TIM_Prescaler = 55;					    //ԤƵֵ
	TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;		//ʱӷָ
	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;	//TIMϼģʽ
	TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure);

	TIM_ARRPreloadConfig(TIM2, ENABLE);
	
//	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);
//	
	NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	
	NVIC_Init(&NVIC_InitStructure);
	
	TIM_ClearITPendingBit(TIM2, TIM_IT_Update);
	TIM_ITConfig(TIM2, TIM_IT_Update, DISABLE);
//	TIM_ClearFlag(TIM2, TIM_FLAG_Update); //жϱ־
	
	TIM_Cmd(TIM2, DISABLE);

  return 1;
}

void
vMBPortTimersEnable( void )
{
	TIM_ClearFlag(TIM2, TIM_FLAG_Update); //жϱ־
	TIM_SetCounter(TIM2,0x00);			//ֵ
	TIM_ITConfig(TIM2,TIM_IT_Update,ENABLE);
	TIM_Cmd(TIM2,ENABLE);
}

void
vMBPortTimersDisable( void )
{
	TIM_Cmd(TIM2, DISABLE);
	TIM_SetCounter(TIM2,0x00);	
	TIM_ITConfig(TIM2,TIM_IT_Update,DISABLE);
	TIM_ClearFlag(TIM2, TIM_FLAG_Update); //жϱ־
}


void prvvTIMERExpiredISR( void )
{
	( void )pxMBPortCBTimerExpired();
}

/**
  * @brief  ʱ4жϷ
  * @param  None
  * @retval None
  */
void TIM2_IRQHandler(void)
{
  if (TIM_GetITStatus(TIM2, TIM_IT_Update) != RESET)
  {
    //ʱT4жϱ־λ
    TIM_ClearITPendingBit(TIM2, TIM_IT_Update);

    prvvTIMERExpiredISR( );
  }
}

