/*
**
**                           Main.c
**
**
**********************************************************************/
/*
   Last committed:     $Revision: 00 $
   Last changed by:    $Author: $
   Last changed date:  $Date:  $
   ID:                 $Id:  $

**********************************************************************/
#include "stm32f10x_conf.h"

#include "delay.h"
#include "usart.h"

#include "freeRTOS.h"
#include "task.h"

#include "beep.h"
#include "key.h"
#include "led.h"
#include "lcd.h"
#include "oled.h"


/* The check task uses the sprintf function so requires a little more stack. */
#define mainCHECK_TASK_STACK_SIZE			( configMINIMAL_STACK_SIZE + 50 )
#define mainCHECK_TASK_PRIORITY				( tskIDLE_PRIORITY + 3 )

static void prvCheckTask( void *pvParameters );
static void prvListTask(void *pvParameters);
static void prvOLEDTask(void *pvParameters);



int main(void)
{

    char szDemo[] = "Hello STM32\r\n";

    delay_init(72);
    uart_init(115200);
    BEEP_Init();
    KEY_Init();
    LED_Init();
    LCD_Init();
    OLED_Init();

    sprintf(szDemo, "Hello %f\r\n", 3.14);

    printf("%s", szDemo);

    OLED_ShowString(0,0, "0.96' OLED TEST");
 	OLED_ShowString(0,16,"Bula@WarShip");
 	OLED_ShowString(0,32,"2016/05/14");
 	OLED_ShowString(0,48,"ASCII:");
 	OLED_ShowString(63,48,"CODE:");
	OLED_Refresh_Gram();

	LCD_ShowString(60,50,200,16,16,"WarShip STM32");
	LCD_ShowString(60,70,200,16,16,"FreeRTOS EmBitz");
	LCD_ShowString(60,90,200,16,16,"Bula@WarShip");
	LCD_ShowString(60,110,200,16,16,"2016/05/14");
	LCD_ShowString(60,130,200,16,16,"ASCII:  CODE:");


    xTaskCreate( prvCheckTask, "Check", mainCHECK_TASK_STACK_SIZE+0x80, NULL, mainCHECK_TASK_PRIORITY, NULL );
    xTaskCreate( prvListTask, "List", mainCHECK_TASK_STACK_SIZE+0x80, NULL, mainCHECK_TASK_PRIORITY, NULL );
    xTaskCreate( prvOLEDTask, "OLED", mainCHECK_TASK_STACK_SIZE+0x80, NULL, mainCHECK_TASK_PRIORITY, NULL );

	vTaskStartScheduler();

    while(1) {}
}

static void prvCheckTask( void *pvParameters )
{
    uint8_t i = 0;
    float pi=3.1415926;

    while(1)
    {
        printf("hello Bulent %d=%f\r\n", i++, pi);
        LED0 = !LED0;
        if (i > 99) i = 0;
        vTaskDelay(500 / portTICK_RATE_MS);
    }
}

char szTaskList[512];
static void prvListTask(void *pvParameters)
{
    uint8_t t;
    char buf[32];

    t = ' ';

    while(1)
	{
		LCD_ShowString(110,130,200,16,16,&t);//显示ASCII字符
		t++;
		if(t>'~')t=' ';
		sprintf(buf, "%d", t);
        LCD_ShowString(170,130,200,16,16,buf);//显示ASCII字符的码值
		LED1=!LED1;
		vTaskDelay(500 / portTICK_RATE_MS);

	}
}

static void prvOLEDTask(void *pvParameters)
{
    uint8_t t;

    t = ' ';

    while(1)
	{
		OLED_ShowChar(48,48,t,16,1);//显示ASCII字符
		OLED_Refresh_Gram();
		t++;
		if(t>'~')t=' ';
		OLED_ShowNum(103,48,t,3,16);//显示ASCII字符的码值
		LED0=!LED0;
		vTaskDelay(500 / portTICK_RATE_MS);

	}
}


